#include "AppEvent.ch"
#include "dcdialog.ch"

#pragma Library("DCLIPX.lib")
#pragma LIBRARY("XBTBASE1.lib")
#pragma LIBRARY("XBTBASE2.lib")

#define CRLF  chr(13)+chr(10)
#define GRA_CLR_HEADNORMAL    GraMakeRGBColor({186,214,235})
#define GRA_CLR_HEADSORTBAR   GraMakeRGBColor({57,136,193})
#define GRA_CLR_HEADSELECTED  GraMakeRGBColor({113,170,213})
#define GRA_CLR_HIGHLIGHT     GraMakeRGBColor({255,204,153})

****************************************************************************
PROC appsys ; RETURN
****************************************************************************
FUNCTION Main()
local x:="", oSuchDlg
*, aArray:=dc_array_r(".\KotaTmp.arr")
local aSpalten, nSortSp, s:="", i
local aArray:=PerformerNames()

DC_BrowPres({ ;
   {XBP_PP_COMPOUNDNAME, "10.Arial" }, ;
   {XBP_PP_COL_DA_FGCLR, GRA_CLR_BLACK }, ;
   {XBP_PP_COL_DA_BGCLR, GRA_CLR_WHITE}, ;
   {XBP_PP_HILITE_FGCLR, GRA_CLR_BLACK }, ;
   {XBP_PP_HILITE_BGCLR, GRA_CLR_HIGHLIGHT }, ;
   {XBP_PP_COL_DA_ROWHEIGHT, 20 }, ;
   {XBP_PP_COL_DA_CELLHEIGHT, 20 }, ;
   {XBP_PP_COL_HA_COMPOUNDNAME, "8.Arial" } ;
  })

*** Farbe fr Browse-Header mit Sort setzen
DC_BrowseSort( { GRA_CLR_BLACK, ;
                 GRA_CLR_HEADNORMAL , ;
                 GRA_CLR_WHITE, ;
                 GRA_CLR_HEADSORTBAR , ;
                 NIL, ;
                 NIL, ;
                 GRA_CLR_WHITE, ;
                 GRA_CLR_HEADSELECTED })


*aSpalten:={{"Name",18,.T.}, {"Telefon",12,.T.}, {"Bemerkung",20,.T.}}
aSpalten:={{"Name",18,.T.}}
nSortSp:=1

oSuchDlg:=SortSuchArray():new(aArray,aSpalten,nSortSp)
x:=oSuchDlg:show()
Classdestroy(oSuchDlg)
if !empty(x)
** Liefert array-Element zurck
   for i:=1 to len(x)
      if i>1
         s+=";"
      endif
      s+=x[i]
   next
   DC_WinAlert(s)
else
   DC_WinAlert("No Selection")
endif
return nil
***********************************************************************************
***********************************************************************************
CLASS SortSuchArray

EXPORTED:
VAR aAnz, aDaten, aSpalten, nArrLen, nSortCol

METHOD Init, SortArrCol, FilterArr, Show

ENDCLASS
***********************************************************************************
METHOD SortSuchArray:Init(aD,aK,spnr)
   ::aDaten:=aD
   ::aSpalten:=aK
   ::nArrLen:=len(::aDaten)
   ::nSortCol:=1
   if !empty(spnr)
      ::nSortCol:=spnr
   endif
   ::aAnz:={}
   ::SortArrCol()
RETURN self
***********************************************************************************
METHOD SortSuchArray:SortArrCol()
::aAnz:=AClone(ASort(::aDaten,,,{|x,y| upper(x[::nSortCol])<upper(y[::nSortCol])}))
RETURN self
***********************************************************************************
METHOD SortSuchArray:FilterArr(cStr)
local i
   if empty(cStr)
      ::SortArrCol()
   else
      ASize(::aAnz,0)
      for i:=1 to ::nArrLen
         if upper(alltrim(cStr)) $ upper(::aDaten[i][::nSortCol])
            AAdd(::aAnz, ::aDaten[i])
         endif
      next
   endif
   if empty(::aAnz)
      ::aAnz:={{"","",""}}
   endif
   return self
***********************************************************************************
METHOD SortSuchArray:Show()
local GetList:={}, GetOptions, lExitSt, aRef[2], oDlg, retw:=""
local area:=dc_GetWorkArea()
local HelpSuStr:=space(12)
local oAswSuch, oBrowseAsw, nPointer:=1, i
local bSortCol:={|a,n,o| ::nSortCol:=n, HelpSuStr:=space(12), ::SortArrCol(), ::FilterArr(""), dc_getbrowarray(oBrowseAsw, ::aAnz), oBrowseAsw:refreshAll(), dc_getrefresh(Getlist)}


DCGET OPTIONS TABSTOP NORESIZE WINDOWHEIGHT area[4]-10 WINDOWWIDTH area[3]

@1,1 DCSAY "Search: " GET HelpSuStr ;
      PICTURE "@K !!!!!!!!!!!!" ;
      TABSTOP ;
      GETOBJECT oAswSuch ;
      GETID "IDSUCH" ;
      KEYBLOCK {|a,b,o,s| s:=alltrim(o:Editbuffer()), ::FilterArr(s), dc_getbrowarray(oBrowseAsw, ::aAnz), oBrowseAsw:highlight(alltrim(s)), oBrowseAsw:refreshAll() } ;
      GOTFOCUS {|| HelpSuStr:=space(12), ::FilterArr(""), dc_getbrowarray(oBrowseAsw, ::aAnz), oBrowseAsw:highlight(""), oBrowseAsw:refreshAll(), DC_GetRefresh(Getlist,"IDSUCH") } ;
      ACCELKEY xbeK_ALT_S

@1,25 DCPUSHBUTTON CAPTION "All" SIZE 10,1 ACTION {|| HelpSuStr:=space(12), ::FilterArr(""), dc_getbrowarray(oBrowseAsw, ::aAnz), oBrowseAsw:highlight(""), oBrowseAsw:refreshAll(), DC_GetRefresh(Getlist,"IDSUCH")}

@4,0.5 DCBROWSE oBrowseAsw ;
       DATA ::aAnz ;
       POINTER nPointer ;
       SIZE 80, 25 ;
       PRESENTATION DC_BrowPres() ;
       CURSORMODE XBPBRW_CURSOR_ROW ;
       FIT ;
       SUBCLASS 'XbpBrowseHighlight()' ;
       EVAL {|o| o:UseVisualStyle:=.F. } ;
       ITEMSELECTED {|| DC_ReadGuiEvent(DCGUI_EXIT_OK,GetList) }

for i:=1 to len(::aSpalten)

   if ::aSpalten[i][3]
      if i=::nSortCol
         DCBROWSECOL ELEMENT i HEADER ::aSpalten[i][1] WIDTH ::aSpalten[i][2] PARENT oBrowseAsw SORT bSortCol LEFTBUTTON DEFAULT EVAL {|o| o:DataArea:DrawMode := XBP_DRAW_OWNER }
      else
         DCBROWSECOL ELEMENT i HEADER ::aSpalten[i][1] WIDTH ::aSpalten[i][2] PARENT oBrowseAsw SORT bSortCol LEFTBUTTON EVAL {|o| o:DataArea:DrawMode := XBP_DRAW_OWNER }
      endif
   else
      DCBROWSECOL ELEMENT i HEADER ::aSpalten[i][1] WIDTH ::aSpalten[i][2] PARENT oBrowseAsw EVAL {|o| o:DataArea:DrawMode := XBP_DRAW_OWNER }
   endif
next

DCREAD GUI ;
   TO lExitSt ;
   TITLE "Selection" ;
   PARENT @oDlg ;
   OPTIONS GetOptions ;
   MODAL ;
   SETAPPWINDOW ;
   FIT ;
   HANDLER DefBrwHandler REFERENCE aRef ;
   EVAL {|| aRef[1]:=oBrowseAsw, aRef[2]:=oAswSuch } ;
   SETFOCUS @oBrowseAsw


if lExitSt
   retw:=::aAnz[nPointer]
endif
return retw
***************************
FUNCTION DefBrwHandler( nEvent, mp1, mp2, oXbp, GetList, oDialog, aRef)
local oBrw:=aRef[1], oS:=aRef[2]
Unused(oDialog); Unused(Getlist)

IF nEvent == xbeP_SetDisplayFocus
   *** damit bei Programmwechsel Focus richtig steht.
   SetAppWindow(oXbp)
   SetAppFocus(oS)
endif
IF nEvent == xbeP_Keyboard .and. (SetAppFocus()==oBrw)
   if mp1>=32 .and. mp1<165
      SetAppFocus(oS)
      PostAppEvent(xbeP_Keyboard,mp1,mp2,oS)
   endif
elseif nEvent == xbeM_Wheel .and. (SetAppFocus()<>oBrw)
   SetAppFocus(oBrw)
   PostAppEvent(xbeM_Wheel,mp1,mp2,oBrw)
ENDIF
RETURN DCGUI_NONE
*********************************************************************************************************
** Hebt einen Suchbegriff blau hervor, verwendet bei Auftragssuche und bei Telefonkontakte
***************************************
CLASS XbpBrowseHighlight FROM DC_XbpBrowse
***************************************
PROTECTED:
   VAR cHighlight

EXPORTED:
   INLINE METHOD destroy
   *********************
      ::cHighlight:= nil
      ::DC_XbpBrowse:destroy()
   RETURN self

   INLINE METHOD init( oParent, oOwner, aPos, aSize, aPP, lVisible, oGetList )
   *****************************************************************
      ::DC_XbpBrowse:init( oParent, oOwner, aPos, aSize, aPP, lVisible, oGetList )
         ::drawMode:= XBP_DRAW_OWNER
         ::cHighlight := ''
   RETURN self

   INLINE METHOD create( oParent, oOwner, aPos, aSize, aPP, lVisible )
   *******************************************************************
      ::DC_XbpBrowse:create( oParent, oOwner, aPos, aSize, aPP, lVisible )
   RETURN self


   INLINE METHOD customDrawCell( oPS, aInfo )
   ******************************************
     LOCAL xData, nPos, aRect, cSubstr

     xData:= aInfo[ XBP_DRAWINFO_AREA ]:getCell( aInfo[ XBP_DRAWINFO_ITEM ] )

     IF xData <> nil .AND. ( nPos:= At( ::cHighlight, upper(xData) ) ) > 0

        cSubStr:=substr(xData,nPos,len(::cHighlight))

        oPS:setColor( IIF( aInfo[ XBP_DRAWINFO_STATE ] = XBP_DRAWSTATE_SELECTED, XBPSYSCLR_MENUHILITE, XBPSYSCLR_WINDOWSTATICTEXT ) )

        GraCaptionStr( oPS, aInfo[ XBP_DRAWINFO_RECT ], { aInfo[ XBP_DRAWINFO_RECT, 3 ], aInfo[ XBP_DRAWINFO_RECT, 4 ] }, xData )

        oPS:setColor( GRA_CLR_BLUE )

        IF nPos = 1
           GraCaptionStr( oPS, aInfo[ XBP_DRAWINFO_RECT ], { aInfo[ XBP_DRAWINFO_RECT, 3 ], aInfo[ XBP_DRAWINFO_RECT, 4 ] }, cSubStr )
        ELSE
           aRect:= GraQueryTextBox( oPS, Left( xData, nPos - 1 ) )
           GraCaptionStr( oPS, { aInfo[ XBP_DRAWINFO_RECT, 1 ] + aRect[ 3, 1 ], aInfo[ XBP_DRAWINFO_RECT, 2 ] }, { aInfo[ XBP_DRAWINFO_RECT, 3 ], aInfo[ XBP_DRAWINFO_RECT, 4 ] }, cSubstr )
        ENDIF
        RETURN .F.
     ENDIF
   RETURN .T.

   INLINE METHOD highlight( cStr )
   *******************************
      ::cHighlight:= cStr
      ::invalidateRect()
   RETURN self
ENDCLASS

STATIC FUNCTION PerformerNames()
local aTmp, aRet:={},i
aTmp:={ ;
   'Annie Hall', ;
   'Arlo Guthrie', ;
   'Bette Midler', ;
   'Bob Dylan', ;
   'Bobbie Gentry', ;
   'Buddy Holly', ;
   'Canned Heat', ;
   'Carol Elliot', ;
   'Carole King', ;
   'Caroline Aikin', ;
   'Cat Stevens', ;
   'Catie Curtis', ;
   'Cheryl Wheeler', ;
   'Chuck Prophet', ;
   'Chuck Pyle', ;
   'Crosby, Stills, Nash', ;
   'Danny Kaye', ;
   'Dar Williams', ;
   'Dr Hook', ;
   'Eliza Gilkyson', ;
   'Elton John', ;
   'Elvis Presley', ;
   'Gail Davies', ;
   'Glenn Miller', ;
   'Gordon Rowland', ;
   'Greg Brown', ;
   'Harry McClintock', ;
   'Itzhak Perlman', ;
   'James Taylor', ;
   'Jan Stanfield', ;
   'Jefferson Airplane', ;
   'Jim Croce', ;
   'Jimi Hendrix', ;
   'Jimmy Dean', ;
   'John Denver', ;
   'Joni Mitchell', ;
   'Journey', ;
   'Kevin Welch', ;
   'Krystian Zimermann', ;
   'Led Zeppelin', ;
   'Lyle Lovett', ;
   'Lynn Miles', ;
   'Madeleine Peyroux', ;
   'Michael Jackson', ;
   'Michael Lille', ;
   'Mumbo Gumbo', ;
   'Norah Jones', ;
   'Ray Charles', ;
   'Richard Pryor', ;
   'Richard Shindell', ;
   'Richie Havens', ;
   'Robin Williams', ;
   'Roy Orbison', ;
   'Sam Cooke', ;
   'Slobberbone', ;
   'Steppenwolf', ;
   'Susan Werner', ;
   'Ten Years After', ;
   'The Beatles', ;
   'The Doors', ;
   'The Eagles', ;
   'The Flatlanders', ;
   'The Moody Blues', ;
   'Tim Bays', ;
   'Toby Keith', ;
   'Tom Paxton', ;
   'Tom Petty', ;
   'Tom Prasada-Rao', ;
   'Van Morrison', ;
   'Vance Gilbert', ;
   'Vic Chestnutt', ;
   'Willie Nelson', ;
   'Yo-yo Ma', ;
   'Yundi Li'}

for i:=1 to len(aTmp)
   AAdd(aRet,{aTmp[i], "",""})
next
return aRet
